{$R-,S-} {$ifdef FPC} {$mode tp} {$endif}
{$ifdef VER55} {$M 4096,0,0} {$endif}

program dbplus; {public domain, free for any use, nenies proprajho}

const perline:integer=16; showofs:boolean=true;
var f:file; fname:string;

procedure getarg;
const usagemsg = 'Usage:  db.exe [-q] myfile.dat' +
                 ' [number_of_bytes_per_line]';

  procedure grab(n:integer);
  var num,errpos:integer;
  begin fname := paramstr(n);
    val(paramstr(n+1),num,errpos);
    if (errpos=0) and (num > 0) then perline := num
  end; {grab}

  function quiet: boolean;
  var s:string;
  begin s := paramstr(1);
    quiet := ((s[1]='-') or (s[1]='/')) and (upcase(s[2])='Q')
  end; {quiet}

begin
  case paramcount of
    0: begin writeln(usagemsg); halt(255) end;
    1: begin fname := paramstr(1) end;
    2: begin
         if quiet then begin
           showofs := false; fname := paramstr(2)
         end
         else grab(1)
       end;
    3: begin
         if quiet then begin
           showofs := false; grab(2)
         end
         else grab(1)
       end;
  end
end; {getarg}

procedure dump;
type str2=string[2]; str8=string[8]; str16=string[16];

const hexofs:longint=0; halfmeg=(1024 * 1024) shr 1; maxline=80;
  table:str16='0123456789ABCDEF';

var i:byte; line:string; buf:array [1..maxline] of byte; bytesread:word;

  function writelong(l:longint): str8;
  const hex:str8='HHHHHHHH';
  var j:1..8;
  begin
    for j := 8 downto 2 do begin
      hex[j] := table[(l and $0F)+1];
      l := l shr 4
    end;
    hex[1] := table[(l and $0F)+1];
    writelong := hex
  end; {writelong}
  
  function writebyte(b:byte): str2;
  const hex:str2='XX';
  begin
  {$ifdef VER55}
    inline(
      (* $CC/        { int3           } *)

      (* $8A/$46/<b/ { mov al,b       } *)
      $8A/$D0/       { mov dl,al      }
      $D0/$E8/       { shr al,1       }
      $D0/$E8/       { shr al,1       }
      $D0/$E8/       { shr al,1       }
      $D0/$E8/       { shr al,1       }
      $3C/$0A/       { cmp al,10      }
      $1C/$69/       { sbb al,105     }
      $2F/           { das            }
      $8A/$C8/       { mov cl,al      }
      $80/$E2/15/    { and dl,15      }
      $8A/$C2/       { mov al,dl      }
      $3C/$0A/       { cmp al,10      }
      $1C/$69/       { sbb al,105     }
      $2F/           { das            }
      $8A/$E8/       { mov ch,al      }
      $89/$0E/hex+1  { mov [hex+1],cx }
    );
  {$else}
    hex[2] := table[(b and $0F)+1];
    hex[1] := table[(b shr 4)+1];
  {$endif}
  writebyte := hex
  end; {writebyte}

begin {dump} if perline > maxline then perline := maxline;
  while not eof(f) do begin
    line := '';
    blockread(f,buf,perline,bytesread);
    for i := 1 to bytesread-1 do line := line + writebyte(buf[i]) + ' ';
    if showofs then write(writelong(hexofs),': ');
    writeln(line,writebyte(buf[bytesread]));
    inc(hexofs,bytesread);

    {$ifndef NOPROGRESS}
      {$ifdef VER55}
      if (hexofs and (halfmeg-1)=0) then inline($B0/$2E/$CD/$29)
      {$endif}
    {$endif}
  end;
  if showofs then writeln(writelong(hexofs))
end; {dump}

begin {main} getarg; assign(f,fname);
  filemode := 0; {$I-} reset(f,1); {$I+}
  if IOresult=0 then begin
    dump;
    close(f)
  end
  else begin
    writeln('''',fname,''' not found!');
    halt(1)
  end
end.
