;program : Tiny Paint
;compiler : NASM
;system : DOS
;author : Macgub
;email : macgub3@wp.pl
bits 16
org 0x100 
  x	dw 0
  y	dw 0
  color	dw 0

; set 320x200x256 VGA mode
	mov	ax, 0x13
	int	0x10
	call	InitMouse
	call 	DrawColors
	call	ShowCursor
main_loop:
	call	GetMouse
	cmp	bx,2
	jnz	dalej
	call	clrscr
	call	DrawColors
dalej:
	dec	bx
	jnz	checkESC
;right pressed
	push	cx
	push	dx
	cmp	dx,193
	jg	setcol
	jmp	go
setcol:
	mov	word[color],cx
;putpixel
  go:
	call	HideCursor
	mov	cx,word[color]
	pop	bx
	pop	ax
                call	putpixel
	call	ShowCursor
; check if ESC pressed

checkESC:
in	al, 0x60
	dec	al
	jz	break_main_loop
	jmp	main_loop


break_main_loop:
	call	HideCursor
; set text mode
	mov	ax, 0x3
	int	0x10
; quit to DOS
	mov	ah, 0x4c
	int	0x21


;put pixel********* ax-x , bx-y, cx - color
putpixel: 
; push    es
;  push    di
  push    cx
  mov     cx,bx
  shl       bx,8
  shl       cx,6
  add      bx, cx
  add      ax,bx
  mov     bx,0xA000
  mov     es,bx
  mov     di,ax
  pop      cx
  mov     ax,cx
  stosb
;  pop      di
;  pop      es
  ret
;*********
DrawColors:
	
	mov bx, 194	;y
   hoop:
	mov ax, 0		;x
	mov cx, 0		;color
    oop:
	push bx
	call putpixel
	pop bx
	inc cx
	inc ax
	cmp cx, 255
	jnz oop
	inc bx
	cmp bx,200
	jnz hoop
	ret
;*************
InitMouse:
	xor ax,ax
	int 33h
	ret
;***********out cx - x position, dx - y position, bx - buttons
GetMouse:
	mov ax,3
	int 33h
	shr cx,1
	ret
;**********out ax - buttons
GetMouseButtons:
	mov ax,3
	int 33h
	mov ax ,bx
	ret
;***********
ShowCursor:
  mov ax,1
  int 33h
  ret
;****************
HideCursor:
  mov ax,2
  int 33h
  ret
;**************in es:di - adres bufora
CopyToBuf:
;	xor si,si
;	mov ax,0xA000
;	mov ds,ax
;	mov cx,16000
;	cld
;	rep movsd
;	ret
;**************in bx-dlugosc bloku w paragrafach,  out ax-adres segmentowy
AllocateBuf:
;	mov	ah,0x48
;	int	0x21
;	ret
;*************in es - adres segmentowy do zwolnienia
ReleaseBuf:
;	mov ah,0x49
;	int	0x21
;	ret
;**********ds:dx - pointer to file name, ax:bx
SaveBuf: 
;	mov ah,0x3c
;	mov al,0xff
;	int 0x21
;	mov cx,0xf
;	int 0x21
;*****************
clrscr:
	push 0xa000
	pop es
	xor di, di   	
	mov cx, 64000/4
	xor eax,eax
	cld
	rep stosd
	ret


	  